(function () {
  try {
    return angular.module('bonitasoft.ui.widgets');
  } catch(e) {
    return angular.module('bonitasoft.ui.widgets', []);
  }
})().directive('customToggleButtons', function() {
    return {
      controllerAs: 'ctrl',
      controller: function PbRadioBoxCtrl($scope, $parse, $log, widgetNameFactory,uiTranslateFilter) {

  'use strict';
  var ctrl = this;
  /**
   * Watch the data source and set wrapChoices and $scope.properties.values
   */
  function comparator(initialValue, item) {
    return angular.equals(initialValue, ctrl.getValue(item));
  }

  function createGetter(accessor) {
    return accessor && $parse(accessor);
  }

  this.getLabel = createGetter($scope.properties.displayedKey) || function (item) {
    return uiTranslateFilter(typeof item === 'string' ? item : JSON.stringify(item));
  };
  this.getValue = createGetter($scope.properties.returnedKey) || function (item) {
    return item;
  };

  $scope.$watch('properties.availableValues', function(items){
    if (Array.isArray(items)) {
      var foundValue = items
        .filter(comparator.bind(null, $scope.properties.selectedValue))
        .reduce(function (acc, item) {
          return ctrl.getValue(item);
        }, undefined);
      if (foundValue) {
        $scope.properties.selectedValue = foundValue;
      }
    }
  });
  
  this.name = widgetNameFactory.getName('customToggleButtons');

  if (!$scope.properties.isBound('selectedValue')) {
    $log.error('the customToggleButtons property named "selectedValue" need to be bound to a variable');
  }
  
  this.groupAlignement = function() {
      if ($scope.properties.verticalAlignement) {
          return "btn-group-vertical";
      }
      return "btn-group";
  }

  
}
,
      template: '<div class="text-{{ properties.alignment }}">\n    <div class="form-horizontal">\n        <div class="form-group">\n            <div class="col-xs-{{ 12 - (!properties.labelHidden && properties.labelPosition === \'left\' ? properties.labelWidth : 0) }}">\n               <div ng-class="ctrl.groupAlignement()" >\n                <label ng-class="\'btn btn-\' + properties.buttonStyle"\n                       ng-model="properties.selectedValue"\n                       ng-repeat="option in properties.availableValues track by $index" \n                       btn-radio="ctrl.getValue(option)"\n                       ng-bind-html="ctrl.getLabel(option)">\n                </label>\n                </div>\n            </div>\n            <div ng-messages="$form[ctrl.name].$dirty && $form[ctrl.name].$error " ng-messages-include="forms-generic-errors.html" role="alert"></div>\n        </div>\n    </div>\n</div>'
    };
  });
